/*
 * AutomatonAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "AutomatonAccess.h"
#include "settings/AutomatonSettings.h"

namespace dataAccess {

std::string AutomatonAccess::access ( const std::string & component ) {
	AutomatonSettings::Settings settings = dataAccess::AutomatonSettings::fromString ( component );

	if ( settings == AutomatonSettings::Settings::STATES )
		return "automaton::States";

	if ( settings == AutomatonSettings::Settings::FINAL_STATES )
		return "automaton::FinalStates";

	if ( settings == AutomatonSettings::Settings::INITIAL_STATES )
		return "automaton::InitialState";

	if ( settings == AutomatonSettings::Settings::INPUT_ALPHABET )
		return "automaton::InputAlphabet";

	if ( settings == AutomatonSettings::Settings::TRANSITIONS )
		return "automaton::Transitions";

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
