/*
 * ImmediateRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/ImmediateRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > ImmediateRegistry::getAbstraction ( const std::string & result, std::string value ) {
	auto res = getEntries ( ).find ( result );
	if ( res == getEntries ( ).end ( ) )
		throw std::invalid_argument ( "Entry " + result + " not available." );

	return res->second->getAbstraction ( std::move ( value ) );
}

} /* namespace abstraction */
