/*
 * Result.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Result.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

auto ResultDFALinearString = registration::AbstractRegister < Result, DefaultStateType, const automaton::DFA < > &, const string::LinearString < > & > ( Result::result );
auto ResultDFTARankedTree = registration::AbstractRegister < Result, DefaultStateType, const automaton::DFTA < > &, const tree::RankedTree < > & > ( Result::result );
auto ResultInputDrivenDPDALinearString = registration::AbstractRegister < Result, DefaultStateType, const automaton::InputDrivenDPDA < > &, const string::LinearString < > & > ( Result::result );
auto ResultVisiblyPushdownDPDALinearString = registration::AbstractRegister < Result, DefaultStateType, const automaton::VisiblyPushdownDPDA < > &, const string::LinearString < > & > ( Result::result );
auto ResultRealTimeHeightDeterministicDPDALinearString = registration::AbstractRegister < Result, DefaultStateType, const automaton::RealTimeHeightDeterministicDPDA < > &, const string::LinearString < > & > ( Result::result );
auto ResultDPDALinearString = registration::AbstractRegister < Result, DefaultStateType, const automaton::DPDA < > &, const string::LinearString < > & > ( Result::result );

auto ResultDFALinearString2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::DFA < > &, const string::LinearString < > &, const DefaultStateType & > ( Result::result );
auto ResultDFTARankedTree2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::DFTA < > &, const tree::RankedTree < > &, const DefaultStateType & > ( Result::result );
auto ResultInputDrivenDPDALinearString2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::InputDrivenDPDA < > &, const string::LinearString < > &, const DefaultStateType & > ( Result::result );
auto ResultVisiblyPushdownDPDALinearString2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::VisiblyPushdownDPDA < > &, const string::LinearString < > &, const DefaultStateType & > ( Result::result );
auto ResultRealTimeHeightDeterministicDPDALinearString2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::RealTimeHeightDeterministicDPDA < > &, const string::LinearString < > &, const DefaultStateType & > ( Result::result );
auto ResultDPDALinearString2 = registration::AbstractRegister < Result, DefaultStateType, const automaton::DPDA < > &, const string::LinearString < > &, const DefaultStateType & > ( Result::result );

} /* namespace run */

} /* namespace automaton */
