/*
 * ToGrammar.h
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_TO_GRAMMAR_H_
#define REG_EXP_TO_GRAMMAR_H_

#include "ToGrammarRightRGGlushkov.h"

namespace regexp {

namespace convert {

class ToGrammar {
public:
	/**
	 * Performs conversion.
	 * @return right regular grammar equivalent to source regexp.
	 */
	template < class SymbolType >
	static grammar::RightRG < > convert(const regexp::FormalRegExp < SymbolType > & regexp);
	template < class SymbolType >
	static grammar::RightRG < > convert(const regexp::UnboundedRegExp < SymbolType > & regexp);

};

template < class SymbolType >
grammar::RightRG < > ToGrammar::convert(const regexp::FormalRegExp < SymbolType > & regexp) {
	return grammar::RightRG < >(ToGrammarRightRGGlushkov::convert(regexp));
}

template < class SymbolType >
grammar::RightRG < > ToGrammar::convert(const regexp::UnboundedRegExp < SymbolType > & regexp) {
	return grammar::RightRG < >(ToGrammarRightRGGlushkov::convert(regexp));
}

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_GRAMMAR_H_ */
