#include "GeneralizedLevenshteinBitParalelismTest.h"

#include <string/LinearString.h>
#include <stringology/simulations/GeneralizedLevenshteinBitParalelism.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( GeneralizedLevenshteinBitParalelismTest, "bit paralelism" );
CPPUNIT_TEST_SUITE_REGISTRATION ( GeneralizedLevenshteinBitParalelismTest );

void GeneralizedLevenshteinBitParalelismTest::testSimple() {
  auto text = string::LinearString<>("adbcbaabadbbca");
  auto pattern = string::LinearString<>("adbbca");

  ext::set<unsigned int> expected_result = {2, 3, 4, 5, 6, 8, 10, 11, 12, 13};
  auto result = stringology::simulations::GeneralizedLevenshteinBitParalelism::search(text, pattern, 3);
  CPPUNIT_ASSERT(expected_result == result);
}

void GeneralizedLevenshteinBitParalelismTest::setUp() { }

void GeneralizedLevenshteinBitParalelismTest::tearDown() { }
