/*
 * Character.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "Character.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

Character::Character(char data) : m_data(data) {
}

PrimitiveBase* Character::clone ( ) const & {
	return new Character(*this);
}

PrimitiveBase* Character::clone() && {
	return new Character(std::move(*this));
}

char Character::getData() const {
	return m_data;
}

Character::operator char ( ) const {
	return m_data;
}

void Character::setData(char data) {
	this->m_data = data;
}

int Character::compare(const Character& other) const {
	return m_data - other.m_data;
}

void Character::operator>>(std::ostream& out) const {
	out << "(Character " << m_data << ")";
}

Character::operator std::string() const {
	return std::string(1, m_data);
}

PrimitiveBase * Character::inc() && {
	m_data++;
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::Character > ( );

} /* namespace */
