/*
 * Integer.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Integer.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

Integer::Integer(int data) : m_data(data) {

}

PrimitiveBase* Integer::clone ( ) const & {
	return new Integer(*this);
}

PrimitiveBase* Integer::clone() && {
	return new Integer(std::move(*this));
}

int Integer::getData() const {
	return m_data;
}

Integer::operator int ( ) const {
	return m_data;
}

void Integer::setData(int data) {
	this->m_data = data;
}

int Integer::compare(const Integer& other) const {
	return m_data - other.m_data;
}

void Integer::operator>>(std::ostream& out) const {
	out << "(Integer " << m_data << ")";
}

Integer::operator std::string() const {
	return ext::to_string(m_data);
}

PrimitiveBase * Integer::inc() && {
	m_data++;
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::Integer > ( );

} /* namespace */
