/*
 * Integer.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_INTEGER_H_
#define PRIMITIVE_INTEGER_H_

#include "PrimitiveBase.h"

namespace primitive {

/**
 * Represents symbol in an alphabet.
 */
class Integer final : public PrimitiveBase {
protected:
	int m_data;

public:
	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	explicit Integer ( int data );

	virtual PrimitiveBase * clone ( ) const &;

	virtual PrimitiveBase * clone ( ) &&;

	/**
	 * @return name of the symbol
	 */
	int getData ( ) const;

	explicit operator int ( ) const;

	/**
	 * sets new content of primitive
	 */
	void setData ( int data );

	virtual int compare ( const ObjectBase & other ) const {
		if ( ext::type_index ( typeid ( * this ) ) == ext::type_index ( typeid ( other ) ) ) return this->compare ( ( decltype ( * this ) )other );

		return ext::type_index ( typeid ( * this ) ) - ext::type_index ( typeid ( other ) );
	}

	virtual int compare ( const Integer & other ) const;

	virtual void operator >>( std::ostream & ) const;

	virtual explicit operator std::string ( ) const;

	virtual PrimitiveBase * inc ( ) &&;
};

} /* namespace primitive */

#endif /* PRIMITIVE_INTEGER_H_ */
