#include "ContainerTest.h"

#include "object/Object.h"
#include "container/ObjectsSet.h"
#include "container/ObjectsDeque.h"
#include "container/ObjectsVector.h"
#include "container/ObjectsMap.h"
#include "container/ObjectsTree.h"
#include "container/ObjectsTrie.h"

#include <alib/type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ContainerTest, "container" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ContainerTest );

void ContainerTest::setUp ( ) {
}

void ContainerTest::tearDown ( ) {
}

void ContainerTest::testProperties ( ) {
	CPPUNIT_ASSERT ( std::is_nothrow_move_constructible < container::ObjectsSet < object::Object > >::value );
}

void ContainerTest::testNormalize ( ) {
	ext::deque < int > dint;
	ext::deque < object::Object > dnor = core::normalize < container::ObjectsDeque < int > >::raw ( std::move ( dint ) );
	ext::deque < object::Object > dnor2 = core::normalize < container::ObjectsDeque < object::Object > >::raw ( std::move ( dnor ) );

	container::ObjectsDeque < int > Dint;
	container::ObjectsDeque < object::Object > Dnor = core::normalize < container::ObjectsDeque < int > >::eval ( std::move ( Dint ) );
	container::ObjectsDeque < object::Object > Dnor2 = core::normalize < container::ObjectsDeque < object::Object > >::eval ( std::move ( Dnor ) );

	container::ObjectsVector < int > Vint;
	container::ObjectsVector < object::Object > Vnor = core::normalize < container::ObjectsVector < int > >::eval ( std::move ( Vint ) );
	container::ObjectsVector < object::Object > Vnor2 = core::normalize < container::ObjectsVector < object::Object > >::eval ( std::move ( Vnor ) );

	container::ObjectsMap < int, int > Mintint;
	container::ObjectsMap < object::Object, object::Object > Mnor = core::normalize < container::ObjectsMap < int, int > >::eval ( std::move ( Mintint ) );
	container::ObjectsMap < object::Object, object::Object > Mnor2 = core::normalize < container::ObjectsMap < object::Object, object::Object > >::eval ( std::move ( Mnor ) );

	container::ObjectsTree < int > Tint ( 1 );
	container::ObjectsTree < object::Object > Tnor = core::normalize < container::ObjectsTree < int > >::eval ( std::move ( Tint ) );
	container::ObjectsTree < object::Object > Tnor2 = core::normalize < container::ObjectsTree < object::Object > >::eval ( std::move ( Tnor ) );

	container::ObjectsTrie < int, int > Rintint ( 1 );
	container::ObjectsTrie < object::Object, object::Object > Rnor = core::normalize < container::ObjectsTrie < int, int > >::eval ( std::move ( Rintint ) );
	container::ObjectsTrie < object::Object, object::Object > Rnor2 = core::normalize < container::ObjectsTrie < object::Object, object::Object > >::eval ( std::move ( Rnor ) );
}
