/*
 * BottomOfTheStackSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

BottomOfTheStackSymbol::BottomOfTheStackSymbol() {

}

SymbolBase* BottomOfTheStackSymbol::clone ( ) const & {
	return new BottomOfTheStackSymbol(*this);
}

SymbolBase* BottomOfTheStackSymbol::clone() && {
	return new BottomOfTheStackSymbol(std::move(*this));
}

int BottomOfTheStackSymbol::compare(const BottomOfTheStackSymbol&) const {
	return 0;
}

void BottomOfTheStackSymbol::operator>>(std::ostream& out) const {
	out << "(BottomOfTheStackSymbol)";
}

BottomOfTheStackSymbol::operator std::string () const {
	return BottomOfTheStackSymbol::instance < std::string > ( );
;
}

SymbolBase* BottomOfTheStackSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::BottomOfTheStackSymbol > ( );

} /* namespace */
