/*
 * WildcardSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "WildcardSymbol.h"
#include "Symbol.h"
#include <object/Object.h>
#include "UniqueSymbol.h"

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

WildcardSymbol::WildcardSymbol() {

}

SymbolBase* WildcardSymbol::clone() const & {
	return new WildcardSymbol(*this);
}

SymbolBase* WildcardSymbol::clone() && {
	return new WildcardSymbol(std::move(*this));
}

int WildcardSymbol::compare(const WildcardSymbol&) const {
	return 0;
}

void WildcardSymbol::operator>>(std::ostream& out) const {
	out << "(WildcardSymbol)";
}

WildcardSymbol::operator std::string () const {
	return WildcardSymbol::instance < std::string > ( );
}

SymbolBase* WildcardSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::WildcardSymbol > ( );

} /* namespace */
