/*
 * GrammarBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_BASE_H_
#define GRAMMAR_BASE_H_

#include <object/ObjectBase.h>

namespace grammar {

/**
 * \brief Represents base for a concrete grammar type.
 */
class GrammarBase : public object::ObjectBase {
public:
	/**
	 * @copydoc object::ObjectBase::clone ( ) const &
	 */
	virtual GrammarBase * clone ( ) const & override = 0;

	/**
	 * @copydoc object::ObjectBase::clone ( ) &&
	 */
	virtual GrammarBase * clone ( ) && override = 0;
};

} /* namespace grammar */

#endif /* GRAMMAR_BASE_H_ */
