/*
 * Label.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Martin Zak
 */

#include "Label.h"
#include "PrimitiveLabel.h"
#include <primitive/Primitive.h>

namespace label {

void Label::inc ( ) {
	this->operator ++ ();
}

Label::Label ( int number ) : base::WrapperBase < LabelBase > ( label::PrimitiveLabel ( primitive::Primitive ( number ) ) ) {
}

Label::Label ( char character ) : base::WrapperBase < LabelBase > ( label::PrimitiveLabel { primitive::Primitive ( character ) } ) {
}

Label::Label ( std::string string ) : base::WrapperBase < LabelBase > ( label::PrimitiveLabel { primitive::Primitive ( std::move ( string ) ) } ) {
}

Label::Label ( const char * string ) : Label ( ( std::string ) string ) {
}

} /* namespace label */
