/*
 * PrimitiveLabel.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "PrimitiveLabel.h"
#include <label/Label.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

label::PrimitiveLabel xmlApi < label::PrimitiveLabel >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	label::PrimitiveLabel data(core::xmlApi<primitive::Primitive>::parse(input));
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < label::PrimitiveLabel >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < label::PrimitiveLabel >::xmlTagName ( ) {
	static std::string xmlTagName = "PrimitiveLabel";

	return xmlTagName;
}

void xmlApi < label::PrimitiveLabel >::compose ( ext::deque < sax::Token > & output, const label::PrimitiveLabel & label ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	core::xmlApi < primitive::Primitive >::compose ( output, label.getData ( ) );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < label::PrimitiveLabel > ( );
static auto xmlRead = registration::XmlReaderRegister < label::PrimitiveLabel > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < label::Label, label::PrimitiveLabel > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, label::PrimitiveLabel > ( );

} /* namespace */
