/*
 * LR0ItemsLabel.h
 *
 *  Created on: 29. 4. 2016
 *      Author: Martin Kocicka
 */

#ifndef LR0ITEMS_LABEL_H_
#define LR0ITEMS_LABEL_H_

#include <label/LabelBase.h>
#include <grammar/parsing/LRParserTypes.h>

namespace label {

/**
 * Represents symbol in an alphabet.
 */
class LR0ItemsLabel final : public LabelBase {
protected:
	grammar::parsing::LR0Items m_items;

public:
	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	explicit LR0ItemsLabel ( grammar::parsing::LR0Items items );

	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	explicit LR0ItemsLabel ( );

	virtual LabelBase * clone ( ) const &;

	virtual LabelBase * clone ( ) &&;

	const grammar::parsing::LR0Items & getItems ( ) const {
		return m_items;
	}

	grammar::parsing::LR0Items & getItems ( ) {
		return m_items;
	}

	virtual int compare ( const ObjectBase & other ) const {
		if ( ext::type_index ( typeid ( * this ) ) == ext::type_index ( typeid ( other ) ) ) return this->compare ( ( decltype ( * this ) )other );

		return ext::type_index ( typeid ( * this ) ) - ext::type_index ( typeid ( other ) );
	}

	virtual int compare ( const LR0ItemsLabel & other ) const;

	bool operator < (const LR0ItemsLabel& other) const;

	virtual void operator >>( std::ostream & ) const;

	virtual explicit operator std::string ( ) const;

	virtual LabelBase * inc ( ) &&;
};

} /* namespace label */

#endif /* LR0ITEMS_LABEL_H_ */
