/*
 * GNF.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_GNF_H_
#define _STRING_GNF_H_

#include <grammar/ContextFree/GNF.h>
#include <core/stringApi.hpp>

#include <grammar/GrammarFromStringLexer.h>

#include <grammar/string/common/GrammarFromStringParserCommon.h>
#include <grammar/string/common/GrammarToStringComposerCommon.h>

namespace core {

template<class SymbolType >
struct stringApi < grammar::GNF < SymbolType > > {
	static grammar::GNF < SymbolType > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const grammar::GNF < SymbolType > & grammar );
};

template<class SymbolType >
grammar::GNF < SymbolType > stringApi < grammar::GNF < SymbolType > >::parse ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next(input);
	if(token.type != grammar::GrammarFromStringLexer::TokenType::GNF)
		throw exception::CommonException("Unrecognised GNF token.");

	return grammar::GrammarFromStringParserCommon::parseCFLikeGrammar < grammar::GNF < SymbolType > > ( input );
}

template<class SymbolType >
bool stringApi < grammar::GNF < SymbolType > >::first ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next ( input );
	bool res = token.type == grammar::GrammarFromStringLexer::TokenType::GNF;
	grammar::GrammarFromStringLexer::putback ( input, token );
	return res;
}

template<class SymbolType >
void stringApi < grammar::GNF < SymbolType > >::compose ( std::ostream & output, const grammar::GNF < SymbolType > & grammar ) {
	output << "GNF";
	grammar::GrammarToStringComposerCommon::composeCFLikeGrammar ( output, grammar );
}

} /* namespace core */

#endif /* _STRING_GNF_H_ */
